#!/bin/bash

cd projects/end-nglibrary/;

#bump version ---------------------------------------
versionbump="$1";

if [ "$versionbump" == "major" ] || [ "$versionbump" == "minor" ]  || [ "$versionbump" == "patch" ]
then
  
  echo "bumping version: $versionbump"

  npm --no-git-tag-version version $versionbump;    
fi

#expose components to public_api.ts ---------------------------------------
cd src;

truncate -s 0 'public_api.ts';

find . -name '*.module.ts' ! -path '*/node_modules/*' -o -name '*.component.ts' ! -path '*/node_modules/*' -o -name '*.directive.ts' ! -path '*/node_modules/*' | while read i; do
  if [ "$i" != "./src/app/app-routing.module.ts" ] && [ "$i" != "./src/app/app.component.ts" ]
  then
   strline="export * from '$i'";
   trimextension=
   echo "${strline/.ts\'/"';"}" >> 'public_api.ts';
  fi
done

#build ---------------------------------------
echo "building library";

cd ../../../;

ng build end-nglibrary;

#publish ---------------------------------------
echo "publishing";

cp .npmrc dist/end-nglibrary/.npmrc;

cd dist/end-nglibrary/;

npm publish;




