import { TemplateRef, ContentChildren, QueryList } from "@angular/core";
import { CbxTemplateDirective } from "../directives/cbx-template.directive";

/**
 * Parse querylist of cbxTemplate into a templateDictionary
 * must call `super.ngAfterContentInit()` if ngAfterContentInit() is present on child class
 */
export class TemplateParserComponent{
    public templateDictionary:{[strname:string]:TemplateRef<any>} = {}
    @ContentChildren(CbxTemplateDirective) templateList:QueryList<CbxTemplateDirective>;

    ngAfterContentInit(){
        if(this.templateList){
            this.templateList.forEach(tpl => this.templateDictionary[tpl.name]=tpl.templateRef);
        }
    }
}