import { Component, Input, EventEmitter, Output, QueryList, ViewChildren, AfterViewInit, AfterContentInit, ContentChildren, forwardRef } from '@angular/core';
import { ButtonToggleComponent } from '../button-toggle/button-toggle.component';

@Component({
  selector: 'button-toggle-group',
  templateUrl: './button-toggle-group.component.html',
  styleUrls: ['./button-toggle-group.component.less'],
})
export class ButtonToggleGroupComponent implements AfterContentInit{

  @ContentChildren(forwardRef(() => ButtonToggleComponent)) _buttonToggles: QueryList<ButtonToggleComponent>;

  @Output()
  change: EventEmitter<any> = new EventEmitter()

  ngAfterContentInit() {
    this._buttonToggles.forEach(item => {
        item.change.subscribe(state => {
          if (state == true)
            this.uncheckOthers(item)
        })
    })
  }

  private uncheckOthers(item: ButtonToggleComponent) {
    this._buttonToggles
      .filter(i => i != item)
      .forEach(i => i.toggle(false))
  }
}
