import { Component, Input, EventEmitter, Output } from '@angular/core';

@Component({
  selector: 'button-toggle',
  templateUrl: './button-toggle.component.html',
  styleUrls: ['./button-toggle.component.less'],
})
export class ButtonToggleComponent {

  @Input()
  checked: boolean = false;

  @Input()
  disabled: boolean = false;

  @Output()
  change: EventEmitter<any> = new EventEmitter()

  toggle(newState: boolean) {
    const dispatchEvent = this.checked != newState
    this.checked = newState;
    if (dispatchEvent)
      this.change.emit(newState);
  }
}
