import { Inject, Injectable, Optional, InjectionToken } from '@angular/core';
//import { BehaviorSubject } from 'rxjs/';
import { MessageService } from './message.service';
// import { map } from 'rxjs/operators';
// import { tap } from 'rxjs/operators';

export const L10N_PREFIX = new InjectionToken('Localization key prefix');
export const RTL = new InjectionToken("UI Right-to-Left token");

@Injectable()
export class L10nService {

    changes: any;
    dictionary:any;
    subscription:any;
    rtl:string;
    constructor(@Inject(L10N_PREFIX) private prefix: string,  private messageService: MessageService) {
        // this.changes = new BehaviorSubject({ rtl: this.rtl });
        // this.dictionary = {};
        // if (messageService) {
        //     this.subscription = messageService.changes
        //         .pipe(map(({ rtl }) => rtl !== undefined ? rtl : rtl), tap(rtl => rtl = rtl))
        //         .subscribe(rtl => {
        //             this.dictionary = {};
        //             this.changes.next({ rtl });
        //         });
        // }

    }

    ngOnDestroy() {
        if (this.subscription) {
            this.subscription.unsubscribe();
        }
    }
    get(shortKey) {
        const key = this.key(shortKey);
        return this.dictionary[key];
    }
    register(shortKey, value, override = false) {
        const key = this.key(shortKey);
        let message = value;
        if (!override) {
            if (this.dictionary.hasOwnProperty(key)) {
                return;
            }
            message = this.defaultValue(key, value);
        }
        this.dictionary[key] = message;
    }
    key(shortKey) {
        return this.prefix + '.' + shortKey;
    }
    defaultValue(key, value) {
        if (!this.messageService) {
            return value;
        }
        const alt = this.messageService.get(key);
        return (alt === undefined) ? value : alt;
    }
}

