import { NgModule } from '@angular/core';
import { CommonModule } from "@angular/common"
import { CbxInputWrapperComponent } from './components/cbx-input-wrapper/cbx-input-wrapper.component';
import { CbxInputDirective } from './directives/cbx-input.directive';
import { CbxToggleComponent } from './components/cbx-toggle/cbx-toggle.component';
import { ButtonToggleComponent } from './components/button-toggle/button-toggle.component';
import { ButtonToggleGroupComponent } from './components/button-toggle-group/button-toggle-group.component';
import { CbxRadioGroupComponent } from './components/cbx-radio-group/cbx-radio-group.component';
import { FormsModule } from '@angular/forms';
import { CbxFormControlLabelComponent } from './components/cbx-form-control-label/cbx-form-control-label.component';
import { CbxFormControlTooltipComponent } from './components/cbx-form-control-tooltip/cbx-form-control-tooltip.component';

import { ArrayOrderByPipe } from './pipes/orderBy.pipe';
import { CbxCheckbox } from './components/cbx-checkbox/cbx-checkbox.component';
import { CbxTemplateDirective } from './directives/cbx-template.directive';
import { CbxDatePicker } from './components/cbx-datetime/datepicker.component';
import { CbxClickOutsideDirective } from './directives/cbx-clickoutside.directive';
import { CbxMaskDirective } from './directives/mask/cbx-mask.directive';
import { NumberUtilitiesService } from './services/number-utilities.service';
import { DataOrPropertyPipe } from './pipes/data-or-property.pipe';
import { CbxInputDate } from './components/cbx-input-date/cbx-input-date.component';
import { I18nService } from './components/cbx-input-date/services/i18n.service';
import { L10N_PREFIX, L10nService } from './components/cbx-input-date/services/l10n.service';
import { MessageService } from './components/cbx-input-date/services/message.service';
import { CbxSlider } from './components/cbx-slider/cbx-slider.component';
import { CbxTooltipDirective } from './directives/cbx-tooltip.directive';
import { CbxTooltipContainerComponent } from './components/cbx-tooltip-container/cbx-tooltip-container.component';
import { GlobalEventsService } from './services/global-events.service';

@NgModule({
  imports: [ CommonModule, FormsModule ],
  declarations: [
    CbxInputWrapperComponent, 
    CbxInputDirective, 
    CbxToggleComponent,
    CbxCheckbox,
    ButtonToggleComponent,
    ButtonToggleGroupComponent,
    CbxRadioGroupComponent,
    CbxFormControlLabelComponent,
    CbxFormControlTooltipComponent,
    ArrayOrderByPipe,
    CbxTemplateDirective,
    CbxDatePicker,
    CbxClickOutsideDirective,
    CbxMaskDirective,
    DataOrPropertyPipe,
    CbxInputDate,
    CbxSlider,
    CbxTooltipDirective,
    CbxTooltipContainerComponent
  ],
  exports: [
    CbxInputWrapperComponent, 
    CbxInputDirective, 
    CbxToggleComponent,
    CbxCheckbox,
    ButtonToggleComponent,
    ButtonToggleGroupComponent,
    CbxRadioGroupComponent,
    CbxFormControlLabelComponent,
    CbxFormControlTooltipComponent,
    ArrayOrderByPipe,
    CbxTemplateDirective,
    CbxDatePicker,
    CbxClickOutsideDirective,
    CbxMaskDirective,
    CbxInputDate,
    CbxSlider,
    CbxTooltipDirective,
    CbxTooltipContainerComponent    
  ],
  entryComponents:[CbxTooltipContainerComponent],
  providers:[
    GlobalEventsService,
    NumberUtilitiesService,
    I18nService,
    L10nService,
    MessageService,
    { provide: L10N_PREFIX, useValue: "cbx.common" }
  ]
})
export class EndNglibraryModule { }
