import { Injectable } from '@angular/core';
import { Subject, Observable } from 'rxjs';

@Injectable()
export class GlobalEventsService {

  constructor() { 
    document.addEventListener("click", this.onClick)
  }

  private focusMap: Map<Node, boolean>;
  private _focusMapStream = new Subject<{click: Event, map: Map<Node, boolean>}>();
  public FocusMapStream = this._focusMapStream as Observable<{click: Event, map: Map<Node, boolean>}>;

  public onClick = (event: Event)=>{
    this.focusMap = new Map<Node, boolean>();
    let target = (event.target as Node);
    while(target != null){
      this.focusMap.set(target, true);
      target = target.parentNode;
    }
    this._focusMapStream.next({
      click: event,
      map: this.focusMap
    });
  }
}
