import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import { DashboardRoutes} from './modules/dashboard/dashboard.routes';
import { DashboardComponent } from './modules/dashboard/dashboard.component';
import { TogglePreviewRoutes } from './modules/toggle/toggle-preview.routes';
import { DatePreviewRoutes } from './modules/datepicker/datepicker-preview.routes';
import { RadioGroupPreviewRoutes } from './modules/radio-group/radio-group-preview.routes';
import { SliderPreviewRoutes } from './modules/slider/slider-preview.routes';
import { TooltipPreviewComponent } from './modules/tooltip-preview/tooltip-preview.component';


const routes: Routes = [
    { path: 'tooltip', component: TooltipPreviewComponent },
    { path: '', component: DashboardComponent },
    ...DashboardRoutes,
    ...TogglePreviewRoutes,
    ...DatePreviewRoutes,
    ...RadioGroupPreviewRoutes,
    ...SliderPreviewRoutes
];

@NgModule({
  imports: [RouterModule.forRoot(routes, {useHash: true})],
  exports: [RouterModule]
})
export class AppRoutingModule { }
