import { Component, ViewChild, ElementRef } from "@angular/core";

@Component({
    templateUrl: "./datepicker-preview.component.html",
    styleUrls: ["./datepicker-preview.component.less"]
})
export class DatePickerPreviewComponent {

    console = window.console;

    date: Date = null;
    date2: Date = new Date();

    Settings = {
        bigBanner: true,
        timePicker: false,
        format: "MM/dd/yyyy",
        placeholder: " ",
        //formatPlaceholder: "{year: 'YYYY', month: 'MM', day: 'DD',hour: 'HH', minute: 'MM', second: 'SS'}",
        defaultOpen: false,
        closeOnSelect: false,
        rangepicker: false
    };




    dateTimeSettings = {
        bigBanner: true,
        timePicker: true,
        format: "MM/dd/yyyy hh:mm a",
        //formatPlaceholder: "formatPattern",
        placeholder: " ",
        defaultOpen: false,
        closeOnSelect: false,
    };

    timeSettings = {
        bigBanner: false,
        timePicker: true,
        timePickerOnly: true,
        format: "hh:mm a",
        //formatPlaceholder: "formatPattern",
        placeholder: " ",
        defaultOpen: false,
        closeOnSelect: false,
    }

    dateRange: any = {
        startDate: new Date("04-18-1990"),
        endDate: new Date("04-20-2017")
    };

    dateRangeSettings = {
        bigBanner: true,
        timePicker: false,
        format: "MM/dd/yyyy",
        defaultOpen: false,
        closeOnSelect: false,
        rangepicker: true,
        //formatPlaceholder: "formatPattern",
        placeholder: " ",
    };

    simpleSettings = {
        bigBanner: false,
        timePicker: false,
        format: "MM/dd/yyyy",
        defaultOpen: false,
        closeOnSelect: false,
    };

    onDateSelect(date: any) {
        console.log(date);
    }

    isDateValid(date) {
        return new Date(date).toLocaleString() !== "Invalid Date";
    }

    validateDate(dateInput, snackbar) {
        if (!this.isDateValid(dateInput.value)) {
            console.log('Invalid date!');
        }
    }
}
