import { Component, ViewChild,ElementRef } from '@angular/core';
import { TestData } from './test-data';
import { FormGroup, FormBuilder, FormControl, NgModel } from "@angular/forms";


@Component({
  templateUrl: './toggle-preview.component.html',
  styleUrls: ['./toggle-preview.component.less']
})

export class TogglePreviewComponent {

    public console = console;

    @ViewChild('result') result: ElementRef;
    @ViewChild('result2') result2: ElementRef;
    public testData: TestData;
    public testData2: TestData;
    testForm: FormGroup;

    reactiveForm : any = {
        optionOne: "Test for option one",
        optionTwo: "Test for option two",
        allowNull: true
    }

    templateDriveForm : any = {
        optionOne: "A very long string that's supposed to truncatee",
        optionTwo: "Another long string",
        allowNull: false
    }

    constructor(private formBuilder: FormBuilder) {

        this.testData = new TestData();
        this.testData.active = true;

        this.testData2 = new TestData({active: null});
        this.testForm = new FormGroup({
            active: new FormControl()
        })
        this.testForm.setValue(this.testData2);

    }

    toggleClick(event) {
        this.result.nativeElement.innerHTML = JSON.stringify(this.testData)

    }
    toggle2Click(event) {
        this.result2.nativeElement.innerHTML = JSON.stringify(this.testForm.value.active);

    }
}